# Welcome to the MSU D2L Instructor API

This repository has been created as a part of CMSE495: Experiential Learning in Data Science at Michigan Sate University. This course is the capstone for the data science major and provides the opportunity for students to work in teams on a sponsored project as a culmination of the skills they have learned. 

The sponsor for the D2L Instructor API project is Michigan State University. The goal of this project is to build a data analysis API for the learning management system to provide more intuitive, insightful, and accesible student performance data to researchers and instructors. Primarily this involves converting D2L's default format for quiz and survey data into a more useful, condensed form. 

## Group Members:
- Olivia Sheng Qiu <qiuolivi@msu.edu>

- Pranay Rahul Pentaparthy <pentapar@msu.edu>

- Erin Elizabeth Sawyer <sawyerer@msu.edu>

- Jonah Masaki Wehner <wehnerjo@msu.edu>

- Jiaye Xie <xiejiaye@msu.edu>

## Milestones and Project Information:

### Project Proposal
Here is a [link](https://mediaspace.msu.edu/media/MSUD2LInstructorAPI-CMSE495_Proposal_Presentation_Video/1_8nkuh5ul) to our proposal presentation video for more information about our project! 

### Closed Loops
Here is a [link](https://mediaspace.msu.edu/media/MSUD2LInstructorAPI-CMSE495_Closed-Loop_Presentation_Video/1_lirffq9v) to our closed loop presentation video for more information about our project! 

### Figure Reproducibility [Outdated]
Our Figure Reproducibility milestone can be found in our repository in the section titled "FigureReproducibility." The notebook file is titled '20230326_MSUD2LInstructorAPI_FigureReproducibility.ipynb' and the accompanying data files are titled "FigureReproducibilityExampleData_QuizAttemptDetails.csv" and "FigureReproducibilityExampleData_AnswerKey.csv." However, this milestone is now outdated. For updated visualizations please see the 'Figures' directory in our repository.

## Navigate Our Repository

The instructions for installing Conda on different systems like "Windows" and "MacOS" can be found in our repository in the section titled "Reports." It contains the CONDA_INSTALLATION.md file and the UsageRequirementsLimitations.md file. The INSTALL.md file also has important instructions for using our software.

There are two different GUIs that can be used to interface with our software. Our current primary GUI uses ipywidgets and can be found under GUI -> WidgetGUI. The other GUI uses tkinter and is still a work in progress.

For an example of using the functions in our library, please see 'UsageExamples.ipynb' in our 'Examples' directory. 

Go to the INSTALL.md for further instructions for the API.
